import React from 'react';
import { Switch, NavLink } from "react-router-dom";
import { connect } from 'react-redux';

import { routes, RouteWithSubRoutes } from './../routes';

class MainCard extends React.Component {
  render() {
    return (
      <div className="gs-settings-card">
        <div className="d--f jc--sb ai--c gs-settings-menubar">
          <ul className="gs-settings-mainmenu">
            <li><NavLink exact to="/">Shortcodes</NavLink></li>
            <li><NavLink to="/settings">Settings</NavLink></li>
            <li><NavLink to="/support">Support</NavLink></li>
          </ul>
          <div>
            <span className="spinner" style={{ visibility: this.props.loading ? 'visible' : 'hidden' }}></span>
          </div>
        </div>
        <div className="gs-settings-card-body">
          <Switch>
            {routes.map( (route, i) => (
              <RouteWithSubRoutes key={i} {...route} />
            ) )}
          </Switch>
        </div>
      </div>
    );
  }
}

function mapStateToProps(state) {
  return { loading: state.loading }
}

export default connect(mapStateToProps)(MainCard)
