import React from 'react';
import { connect } from 'react-redux';

import ThemePosts from '../ThemeItems/Posts';

import { previewLoading } from '../../store';

class ThemePreview extends React.Component {

  constructor(props) {
    super(props);

    this.themeContainer = this.themeContainer.bind(this);
    this.getThemeItem = this.getThemeItem.bind(this);
    this.themeGridContainer = this.themeGridContainer.bind(this);
    this.previewLibraryInitTimer = null;
  }

  render() {
    var { loading, error } = this.props;

    return (
      <div className="theme-appearance-output">
        <div className="preview-text">Preview</div>

        { !! error ?
          ( <div className="theme-appearance-alert-warning">{error}</div> )
          : ( this.themeContainer() )
        }

        <div style={{ display: loading ? 'block': 'none' }}>
          <div className="theme-appearance-loader">
            <div className="gs-preview-spinner">
              <div></div><div></div><div></div><div></div><div></div><div></div>
              <div></div><div></div><div></div><div></div><div></div><div></div>
            </div>
          </div>
        </div>

      </div>
    );
  }

  themeContainer() {
    return this.themeGridContainer();
  }

  getThemeItem() {
    return ThemePosts;
  }

  themeGridContainer() {
    var ThemeItem = this.getThemeItem();
    var themeStyle = this.props.themeStyle;

    return (
      <div className={ "gs-instagram-theme-container " + themeStyle }>
        <div className={"gs-instagram-theme-row " + themeStyle + "-row "}>
          { this.props.items.map( ( item ) => (
            <ThemeItem
              item={item}
              key={item.id.toString()}
              columns={this.props.columns}
              linkTarget={this.props.linkTarget}
            />
          ) ) }
        </div>
      </div>
    );
  }

}

function mapStateToProps( state ) {
  return {
    loading: state.previewLoading,
    items: state.previewItems,
    error: state.previewError,
  };
}

function mapDispatchToProps( dispatch ) {
  return {
    previewLoading: value => dispatch( previewLoading( value ) ),
  };
}

export default connect(mapStateToProps, mapDispatchToProps)(ThemePreview);
