import React from 'react';
import ThemePreview from './ThemePreview';

class ThemeSettings extends React.Component {

  constructor(props) {
    super(props);

    this.themeStyleField = this.themeStyleField.bind(this);
  }

  render() {
    var { form, handleChange } = this.props;

    return (
      <div className="theme-settings-form">
        <h3>Shortcode Settings</h3>

        <div className="theme-settings-appearance d--f">
          <div className="theme-appearance-form">
            <div className="gs-field">
              <label>Instagram Source</label>
              <input type="text" name="source" placeholder="Enter username or tag"
                value={form.source} onChange={handleChange}
              />
            </div>
            <div className="gs-field">
              <label>Source Type</label>
              <select name="source_type" value={form.source_type} onChange={handleChange}>
                <option value="user">User</option>
                <option value="tag">Tag</option>
              </select>
            </div>
            <div className="gs-field">
              <label>Number of Posts</label>
              <input type="number" name="per_page" placeholder="Number of posts per page"
                value={form.per_page} onChange={handleChange}
              />
            </div>
            <div className="gs-field">
              <label>Columns</label>
              <select name="columns" value={form.columns} onChange={handleChange}>
                <option value="4">4 Columns</option>
                <option value="3">3 Columns</option>
              </select>
            </div>

            {this.themeStyleField()}

            <div className="gs-field">
              <label>Posts Link Target</label>
              <select name="link_target" value={form.link_target} onChange={handleChange}>
                <option value="_blank">New Tab</option>
                <option value="_self">Same Window</option>
              </select>
            </div>
          </div>

          <ThemePreview
            themeStyle={this.props.form.theme_style}
            columns={this.props.form.columns}
            linkTarget={this.props.form.link_target}
            userMetaData={this.props.form.user_meta_data}
          />

        </div>
      </div>
    );
  }

  themeStyleField() {
    return (
      <div className="gs-field">
        <label>Theme Style</label>
        <select name="theme_style"
          value={this.props.form.theme_style}
          onChange={this.props.handleChange}
        >
          <option value="gsip-theme-1">Theme 1 (Posts)</option>
          <option value="gsip-theme-2" disabled>Theme 2 (Posts Stat - PRO)</option>
          <option value="gsip-theme-3" disabled>Theme 3 (Hover - PRO)</option>
          <option value="gsip-theme-4" disabled>Theme 4 (Popup - PRO)</option>
          <option value="gsip-theme-5" disabled>Theme 5 (Slider - PRO)</option>
          <option value="gsip-theme-6" disabled>Theme 6 (Profile - PRO)</option>
          <option value="gsip-theme-7" disabled>Theme 7 (Masonry - PRO)</option>
          <option value="gsip-theme-8" disabled>Theme 8 (Grayscale - PRO)</option>
          <option value="gsip-theme-9" disabled>Theme 9 (Justified - PRO)</option>
        </select>
      </div>
    );
  }

  componentDidMount() {

  }

}

export default ThemeSettings;
