import React from 'react';
import { Route } from "react-router-dom";

import Themes from './components/pages/Themes';
import ThemesCreate from './components/pages/ThemesCreate';
import ThemesEdit from './components/pages/ThemesEdit';
import Settings from './components/pages/Settings';
import Support from './components/pages/Support';

export const routes = [
  {
    path: "/",
    component: Themes,
    exact: true,
  },
  {
    path: "/themes/create",
    component: ThemesCreate,
  },
  {
    path: "/themes/:id",
    component: ThemesEdit,
  },
  {
    path: "/settings",
    component: Settings
  },
  {
    path: "/support",
    component: Support
  },
];

export function RouteWithSubRoutes( route ) {
  return (
    <Route
      path={route.path}
      render={props => (
        <route.component {...props} routes={route.routes} />
      )}
    />
  );
}
