import React from 'react';
import { connect } from 'react-redux';

import ThemeWrapper from './components/ThemeWrapper';
import { updateTheme, updateItems, updateNextPageStatus } from './store';

class App extends React.Component {

  constructor( props ) {
    super( props );
  }

  render() {
    return (
      <ThemeWrapper
        themeid={this.props.themeid}
      />
    );
  }

  componentDidMount() {
    jQuery.ajax( {
      method: "GET",
      url: GS_Instagram.ajaxUrl,
      data: {
        action: 'gs_instagram_public_ajax',
        route: 'get_initial_posts',
        body: { themeid: this.props.themeid },
      },
      success: ( response ) => {
        this.props.updateTheme( response.data.theme );
        this.props.updateItems( response.data.items );
        this.props.updateNextPageStatus( response.data.has_next_page );
      }
    } );
  }

}

function mapDispatchToProps( dispatch ) {
  return {
    updateTheme: value => dispatch( updateTheme( value ) ),
    updateItems: value => dispatch( updateItems( value ) ),
    updateNextPageStatus: value => dispatch( updateNextPageStatus( value ) ),
  };
}

export default connect(null, mapDispatchToProps)(App);
